body {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.buttons {
  margin-top: 4rem;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

header {
  margin: 2rem;
}

.btn-collection {
  padding: 4rem;
  display: grid;
  width: 90vw;
  /* responsive grid 
    - auto-fit detects how many columns can fit before wrappin up
    - minimum width 25rem
    - column width can be (some number) auto maximum in this case
  */
  grid-template-columns: repeat(auto-fit, minmax(25rem, auto));
  grid-gap: 4rem;
  place-items: center;
}

a {
  display: grid;
  place-items: center;
  padding: 2rem 4rem;
  position: relative;
  text-transform: uppercase;
  letter-spacing: var(--letterSpacing);
  font-family: var(--headingFont);
  user-select: none;
}

.btn-1 {
  background: var(--accent);
  color: var(--primary);
  border-radius: var(--borderRadius);
  transition: var(--transition);
}

.btn-1::after,
.btn-1::before {
  content: "";
  position: absolute;
  opacity: 0.3;
  background: var(--accent);
  border-radius: inherit;
  width: 100%;
  height: 100%;
  left: 0;
  bottom: 0;
  z-index: -1;
  transition: var(--transition);
}

.btn-1:hover {
  transform: translate(-12px, -12px);
}

.btn-1:hover::after {
  transform: translate(6px, 6px);
}

.btn-1:hover::before {
  transform: translate(12px, 12px);
}

.btn-2 {
  color: var(--accent);
}

.btn-2:hover {
  color: var(--accent);
}

.btn-2::after,
.btn-2::before {
  border: var(--border);
  content: "";
  position: absolute;
  width: calc(100%);
  height: calc(100%);
  left: 0;
  bottom: 0;
  z-index: -1;
  transition: var(--transition);
}

.btn-2:hover::after {
  transform: translate(-5px, -5px);
}
.btn-2:hover::before {
  transform: translate(5px, 5px);
}

.btn-3 {
  background: var(--accent);
  color: var(--primary);
}

.btn-3 > span {
  display: inline-block;
}

.btn-3:hover > span {
  opacity: 0;
}

.moving {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  overflow: hidden;
  pointer-events: none;
}

.moving-letters {
  width: fit-content;
  display: flex;
  position: relative;
  --offset: 1rem;
  --move-initial: calc(-25% + var(--offset));
  --move-final: calc(-50% + var(--offset));
  transform: translate3d(var(--move-initial), 0, 0);
  animation: movingLetters 1s linear infinite;
  animation-play-state: paused;
  opacity: 0;
}

.btn-3:hover .moving-letters {
  animation-play-state: running;
  opacity: 1;
  transition-duration: 0.4s;
}

.moving span {
  text-align: center;
  white-space: nowrap;
  font-style: italic;
  padding: 2rem 0.5rem;
}

@keyframes movingLetters {
  0% {
    transform: translate3d(var(--move-initial), 0, 0);
  }

  100% {
    transform: translate3d(var(--move-final), 0, 0);
  }
}

.btn-4 {
  border: var(--border);
  outline: none;
}

.btn-4:hover {
  color: var(--accent);
}

.btn-4::before {
  content: "";
  position: absolute;
  height: 2rem;
  width: calc(100% + 2px);
  background-color: var(--secondary);
  margin: auto;
  left: -1px;
  right: 0;
  bottom: -1px;
  transition: width 0.3s, height 0.3s 0.3s;
}

.btn-4::after {
  content: "";
  position: absolute;
  height: 2rem;
  width: calc(100% + 2px);
  background-color: var(--secondary);
  margin: auto;
  left: -1px;
  right: 0;
  top: -1px;
  transition: width 0.3s, height 0.3s 0.3s;
}

.btn-4:hover::before,
.btn-4:hover::after {
  width: 0;
  height: 6px;
  transition: height 0.3s, width 0.3s 0.3s;
}

.btn-5 {
  outline: var(--border);
  border: var(--border);
  outline-offset: -2px;
  transition: var(--transition);
  padding: calc(2rem - 2px) calc(4rem - 4px);
}

.btn-5:hover,
.btn-5:focus {
  outline-offset: 2px;
  color: var(--accent);
}

.btn-6 {
  background: var(--accent);
  border: var(--border);
  color: var(--primary);
  outline: 1px solid var(--accent);
  transition: var(--transition);
  padding: calc(2rem - 2px) calc(4rem - 4px);
}

.btn-6:hover,
.btn-6:focus {
  outline-offset: -6px;
  outline: 1px solid var(--primary);
}

.btn-7 {
  color: var(--accent);
  background: rgba(0, 0, 0, 0);
  transition: var(--transition);
}

.btn-7:hover {
  --shadow: 0 0 20px var(--accent), 0 0 80px var(--accent),
    0 0 160px var(--accent), 0 0 320px var(--accent);
  background: var(--accent);
  box-shadow: var(--shadow);
  transition-delay: 0.3s;
}

.btn-7::before,
.btn-7::after {
  border: 0 solid transparent;
  transition: var(--transition);
  content: "";
  height: 0;
  width: 2rem;
  position: absolute;
}

.btn-7::before {
  border-top: 2px solid var(--accent);
  right: 0;
  top: -4px;
}

.btn-7::after {
  border-bottom: 2px solid var(--accent);
  bottom: -4px;
  left: 0;
}

.btn-7:hover::before,
.btn-7:hover::after {
  width: 100%;
}

.btn-8 {
  color: var(--accent);
  width: 190px;
  height: 60px;
  background: linear-gradient(
    -45deg,
    #000285 0%,
    #0400d4 13%,
    #4400e2 25%,
    #8400ff 38%,
    #ab2ef3 50%,
    #dd00c4 62%,
    #ff006e 75%,
    #fe1b06 87%,
    #d90000 100%
  );
  background-size: 400%;
  animation: animateGradient 10s infinite;
}

@keyframes animateGradient {
  0% {
    background-position: 0%;
  }

  50% {
    background-position: 100%;
  }

  100% {
    background-position: 0%;
  }
}

.btn-8_inner {
  position: absolute;
  left: 3px;
  right: 3px;
  top: 3px;
  bottom: 3px;
  background-color: var(--secondary);
  transition: var(--transition);
  text-align: center;
  line-height: 55px;
}

.btn-8_inner:hover {
  background: transparent;
  transition: var(--transition);
}

.btn-9 {
  box-shadow: 1rem 1rem 2rem hsl(194, 21%, 16%),
    -1rem -1rem 2rem hsl(194, 21%, 31%);
  border-radius: var(--borderRadius);
  transition: box-shadow 0.3s ease-in-out;
}

.btn-9:hover {
  color: var(--accent);
}

.btn-9:hover {
  box-shadow: inset 1rem 1rem 2rem hsl(194, 21%, 16%),
    inset -1rem -1rem 2rem hsl(194, 21%, 31%);
  color: var(--accent);
  transition: box-shadow 0.3s ease-in-out;
}

.btn-10 {
  padding: 1rem 2rem;
  display: flex;
  flex-wrap: wrap;
  border: var(--border);
  border-radius: var(--borderRadius);
  transition: var(--transition);
  animation: toTopBtn 2.5s linear;
  animation-delay: 2s;
  animation-fill-mode: forwards;
}

.btn-10 span:nth-child(1) {
  animation: noText 2s linear;
  animation-delay: 2.5s;
  animation-fill-mode: forwards;
}

.btn-10:hover {
  opacity: 0.8;
  color: var(--accent);
}

.btn-10 span:nth-child(2) {
  padding: 0.8rem;
  padding-bottom: 1.2rem;
}

@keyframes toTopBtn {
  0% {
  }

  25% {
    background: var(--primary);
  }

  100% {
    position: absolute;
    bottom: 4rem;
    right: 4rem;
  }
}

@keyframes noText {
  0% {
  }

  25% {
    font-size: 0;
    color: transparent;
  }

  50% {
    position: absolute;
  }

  100% {
    color: transparent;
    position: absolute;
    right: -300px;
  }
}

.btn-11 {
  display: flex;
  flex-wrap: wrap;
}

.btn-11 span {
  padding: 0 0 0.3rem 0.4rem;
}
.btn-11::before {
  content: "";
  border-radius: 50%;
  background-color: var(--accent);
  width: 3.5rem;
  height: 3.5rem;
  margin-right: 0.8rem;
}

.btn-11::after {
  content: "";
  border-radius: 40px;
  background-color: var(--accent);
  width: 3.5rem;
  height: 3.5rem;
  position: absolute;
  top: 2rem;
  z-index: -1;
  transition: var(--transition);
}

.cursor-btn {
  border: var(--border);
}

.btn-11:hover {
  color: var(--primary);
}

.btn-11:hover:after {
  width: 80%;
}

.btn-12 {
  cursor: not-allowed;
  filter: grayscale(1);
  background-color: var(--accent);
  color: var(--primary);
}

.btn-13 {
  cursor: wait;
}

.btn-13:hover {
  color: var(--accent);
}

.btn-14 {
  cursor: move;
}

.btn-14:hover {
  color: var(--accent);
}

.btn-15 {
  cursor: grab;
}

.btn-15:hover {
  color: var(--accent);
}

.hovers {
  padding: 3rem 5rem;
  border: var(--border);
}

.btn-16 {
  cursor: url("./ButtonImg/rhino.png"), auto;
}

.btn-16:hover {
  color: transparent;
}

.btn-17 {
  font-family: var(--textFont);
  text-transform: none;
  font-size: 2.5rem;
  display: flex;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
}

.letterFade {
  animation-duration: 1.3s;
}

.btn-17:hover > .letterFade {
  animation-name: letterFade;
  animation-timing-function: ease;
}

.letterFade:nth-of-type(1) {
  animation-delay: 0.1s;
}
.letterFade:nth-of-type(2) {
  animation-delay: 0.15s;
}
.letterFade:nth-of-type(3) {
  animation-delay: 0.2s;
}
.letterFade:nth-of-type(4) {
  animation-delay: 0.25s;
}
.letterFade:nth-of-type(5) {
  animation-delay: 0.3s;
}
.letterFade:nth-of-type(6) {
  animation-delay: 0.35s;
}
.letterFade:nth-of-type(7) {
  animation-delay: 0.4s;
}

@keyframes letterFade {
  0% {
    opacity: 0.6;
  }
  25% {
    opacity: 0;
    transform: translateX(-100px);
  }
  50% {
    opacity: 0;
  }
  75% {
    transform: translateX(100px);
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

.btn-18 {
  display: flex;
  flex-wrap: wrap;
}

.btn-18::before {
  content: "";
  position: absolute;
  left: 25px;
  background-color: var(--accent);
  width: 0;
  height: 2px;
  z-index: 2;
}

.btn-18:hover::before {
  animation: lineThrough 0.5s ease-in-out forwards;
}

.btn-18 span {
  transition: var(--transition);
}

.btn-18:hover {
  color: var(--accent);
}

.btn-18:hover span {
  font-size: large;
}

@keyframes lineThrough {
  from {
  }
  to {
    width: 75%;
  }
}

.btn-19 {
  font-family: europa, sans-serif;
  font-weight: bold;
}

.btn-19::after {
  content: "";
  position: absolute;
  top: 45px;
  left: 47px;
  background-color: var(--accent);
  width: 50%;
  height: 7px;
  border-radius: 20px;
  transition: var(--transition);
}

.btn-19:hover {
  color: var(--accent);
}

.btn-19:hover::after {
  transition-timing-function: cubic-bezier(0.8, 0, 0.1, 1);
  transition-duration: 0.4s;
  transform: scale3d(1.3, 0.2, 1);
}

.btn-19 span {
  transform: translate3d(0, -4px, 0);
  display: inline-block;
  transition: transform 0.2s 0.05s cubic-bezier(0.2, 0.57, 0.67, 1.53);
}

.btn-19:hover span {
  transform: translate3d(0, 0, 0);
  transition-timing-function: cubic-bezier(0.8, 0, 0.1, 1);
  transition-duration: 0.4s;
  transition-delay: 0s;
}

.btn-20 {
  background-color: hsl(241, 100%, 42%);
  border: 4px solid #000;
  color: #fff;
  -webkit-box-shadow: 4px 4px 0px 0px #000000;
  box-shadow: 4px 4px 0px 0px #000000;
  transform: rotate(-2deg);
  transition: var(--transition);
}

.btn-20:hover {
  color: #fff;
  transform: rotate(0deg);
}

@media (prefers-color-scheme: dark) {
}

@media (prefers-color-scheme: light) {
  a:hover {
    color: var(--primary);
  }

  .btn-4::before,
  .btn-4::after {
    background-color: var(--primary);
  }

  .btn-8_inner {
    background-color: var(--primary);
  }

  .btn-9 {
    box-shadow: 1rem 1rem 2rem hsl(51, 19%, 72%),
      -1rem -1rem 2rem hsl(48, 100%, 93%);
    border-radius: var(--borderRadius);
    transition: box-shadow 0.3s ease-in-out;
  }

  .btn-9:hover {
    box-shadow: inset 1rem 1rem 2rem hsl(51, 19%, 72%),
      inset -1rem -1rem 2rem hsl(48, 100%, 93%);
    color: var(--accent);
    transition: box-shadow 0.3s ease-in-out;
  }

  .btn-12 {
    background: var(--primary);
    color: var(--accent);
  }

  .btn-12:hover {
    color: var(--accent);
  }
}
